//=========================================================================
//       Klasse hh_new
//=========================================================================

#ifndef HH_NEW
#define HH_NEW
#include<iostream.h>
#include<string.h>
#include<stdlib.h>
/*
Mittels den Funktionen dieser Klasse koennen Felder angefordert
(mit hh_new) und freigegeben (mit hh_delete) werden;
dabei bleibt der freie Gesamtspeicherplatz stets zusammenhaengend.
Die Adresse des Speicherplatzes, auf dem die Adresse eines angeforderten
Feldes abgelegt ist, muss fuer jedes angeforderte Feld eine andere sein;
sie ist beim Aufruf zu uebergeben; nach der ersten Verwendung ist der Platz
als konstant und statisch zu behandeln:

char *a[1]; hh_new(a,1000);

Verwendet eine Anweisung einen angeforderten Speicherplatz, so darf bis zum
Ende der Anweisung kein Speicherplatz ueber diese Routinen angefordert oder
freigegeben werden.
Es ist zweckmaessig, diese Klasse als virtuelle Basisklasse fuer Klassen mit
dynamischen Komponenten zu verwenden.
*/

class hh_new
{ static size_t hh_max, // Startblockgroesse
              hh_more,  // Groesse des Erweiterungsblockes,
              *hh_f,    // Zeiger auf den Anfang des Blockes
              *hh_fe,   // 1. freier Platz
               hh_l;    // Anzahl der freien Plaetze (Einheit size_t)
  public:

hh_new(){}

hh_new(char **a, size_t l)        // Feld-Anforderung (in bytes)
  { l++;
    if (!(l=(l%4)? 1+l/4: l/4))
    { cerr << "array length is zero." << endl; exit(1);}
    if (hh_l<l+2)                 // Block-Erweiterung
    { size_t *c, *x, k=(l+2-hh_l<hh_more)? hh_more: l+2-hh_l;
      if(!(c=(size_t*)realloc(hh_f,(k+hh_max)*4)))
      { cerr << "no memory." << endl; exit(1);}
      x=c, hh_l+=k;
      if (hh_f != c)              // Adressen-Korektur
      { while (*x) *((size_t*)*x)=(size_t)(x+2), x+=*(x+1)+2;
        hh_f = c, hh_fe = x;
      }
    }
    *a=(char*)(hh_fe+2), *hh_fe=(size_t)a, *(hh_fe+1)=l;
    hh_fe+=l+2, *hh_fe=0, hh_l-=l+2;
  }

void hh_delete(char **a)          // Feld-Rueckgabe
  { size_t l, *x=hh_f; if(!*a) return;
    while (*x)                    // Feld suchen
    { if ((size_t)(x+2) != (size_t)*a){ x+=*(x+1)+2; continue;}
      l=*(x+1)+2, memcpy(x,x+l,(size_t)(hh_fe-x+l)*4); // Rest-Umspeicherung
      while (*x)                  // Adressen-Korektur
        *((size_t*)*x)=(size_t)(x+2), x+=*(x+1)+2;
      hh_l+=l, hh_fe=x, *a=NULL; return;
    }
  }


void hh_change(char **a, char **b)  // Felder-Tausch:
  { *((size_t*)*a-2)=(size_t)*b; *((size_t*)*b-2)=(size_t)*a;
    char *aa=*a; *a = *b, *b = aa;
  }

};
size_t hh_new::hh_max=32000; // in Einheiten zu size_t
size_t hh_new::hh_more=8000; // in Einheiten zu size_t
size_t* hh_new::hh_f=(size_t*)calloc(hh_max,4);
size_t* hh_new::hh_fe=hh_new::hh_f;
size_t hh_new::hh_l=hh_new::hh_max-3;
#endif
