//=========================================================================
//       String-Klasse hh_string
//=========================================================================

#ifndef HH_STRING
#define HH_STRING
#include <string.h>
#include <fstream.h>
#include <new.h>
#include <stdlib.h>
#include "hh_new.h"

class hh_string: public virtual hh_new
{ friend hh_string operator+(const hh_string&, const hh_string&);
  protected:
  char *a[1];
  size_t *kopie, l_a;

  public:

hh_string(const char *c)
  { l_a = strlen(c); 
    kopie = new size_t, *kopie = 0;
    hh_new(a,l_a), strcpy(*a,c);
  }

hh_string(const hh_string &b)
  { kopie = b.kopie, *kopie += 1, *a = *(b.a), l_a = b.l_a;}

~hh_string(){ if (!*kopie) hh_delete(a), delete kopie; else *kopie -= 1;}

// Aktuelle String-Laenge:
size_t length() const { return l_a;}

// Konvertierung von hh_string in char*:
operator const char* (){ return *a;}

// String-Zuweisung:
hh_string& operator=(const hh_string &b)
  { if (l_a < b.l_a) hh_delete(a), hh_new(a,b.l_a);
    strcpy(*a,*(b.a)), l_a = b.l_a; return *this;
  }

// Einlesen einer Datei als String
hh_string& operator<<(const char *nam)
  { ifstream f(nam); size_t l;
    if (!f.good()){ cerr << "open error. " << nam << endl; exit(1);}
    f.seekg(0,ios::end); l = f.tellg() ;f.seekg(0,ios::beg);
    hh_new(a,l); f.read(*a,l), *(*a+l)='\0', l_a = l; return *this;
  }

// Schreiben eines Strings in eine Datei
hh_string& operator>>(const char *nam)
  { if (!l_a) return *this;
    if(*nam !='\0')
    { ofstream f(nam); f << *a << endl;} else cout << *a << endl;
    return *this;
  }

// Stringerweiterung:
hh_string& operator+=(const hh_string &c)
  { size_t l = *((size_t*)(*a-4));
    if (!c.l_a) return *this;
    if (l < c.l_a+l_a)
    { char *aa[1];
      hh_new(aa,c.l_a+l_a), strcpy(*aa,*a), hh_delete(a), *a = *aa;
    }
    strcat(*a,*(c.a)), l_a+=c.l_a; return *this;
  }

// String-Austausch:
hh_string& change(hh_string &c)
{ hh_change(a,c.a); size_t l = l_a; l_a = c.l_a, c.l_a = l;
  return *this;
}

// Eingabe des i-ten Zeichens:
hh_string& put(size_t i,char c)
  { if(!i || i > l_a){ cerr << " index error. " << i << endl; exit(1);}
    *(*a+i-1) = c; return *this;
  }

// Ausgabe des i-ten Zeichens:
char& get(size_t i)
  { if(!i || i > l_a){ cerr << " index error. " << i << endl; exit(1);}
    return *(*a+i-1);
  }

// Test auf String-Gleichheit:
int operator==(const hh_string &c) const{ return !strcmp(*a,*(c.a));}
int operator==(const char *c) const{ return !strcmp(*a,c);}

// Test auf Ungleichheit:
int operator!=(const hh_string &c) const{ return strcmp(*a,*(c.a));}
int operator!=(const char *c) const{ return strcmp(*a,c);}

// String-Vergleich fuer switch-Anweisung:
int hh_case(char *a1="",char *a2="",char *a3="",char *a4="",\
            char *a5="",char *a6="",char *a7="",char *a8="",\
            char *a9="",char *a10="",char *a11="",char *a12="",\
            char *a13="",char *a14="",char *a15="",char *a16="")
  { if (!strcmp(*a,a1)) return 1;
    if (!strcmp(*a,a2)) return 2;
    if (!strcmp(*a,a3)) return 3;
    if (!strcmp(*a,a4)) return 4;
    if (!strcmp(*a,a5)) return 5;
    if (!strcmp(*a,a6)) return 6;
    if (!strcmp(*a,a7)) return 7;
    if (!strcmp(*a,a8)) return 8;
    if (!strcmp(*a,a9)) return 9;
    if (!strcmp(*a,a10)) return 10;
    if (!strcmp(*a,a11)) return 11;
    if (!strcmp(*a,a12)) return 12;
    if (!strcmp(*a,a13)) return 13;
    if (!strcmp(*a,a14)) return 14;
    if (!strcmp(*a,a15)) return 15;
    if (!strcmp(*a,a16)) return 16;
    return 0;
  }
};
// Aneinanderreihung zweier Strings:

hh_string operator+(const hh_string &l, const hh_string &r)
  { hh_string sum(*(l.a)); return sum += r;}
#endif
